;
; Startup code for cc65 (Vic20 version)
;
; This must be the *first* file on the linker command line
;

	.export		_exit
.export         __STARTUP__ : absolute = 1      ; Mark as startup
	.import		initlib, donelib, callirq
       	.import	       	zerobss, push0
	.import	     	callmain
        .import         RESTOR, BSOUT, CLRCH
	.import	       	__INTERRUPTOR_COUNT__
     	.import		__RAM_START__, __RAM_SIZE__	; Linker generated

        .include        "zeropage.inc"
     	.include     	"vic20.inc"

; ------------------------------------------------------------------------
; Place the startup code in a special segment.

.segment		"GFX"
	.word $1c00
	.byte	0,0,0,0,0,0,0,0
	.byte	0,126,102,126,102,102,0,0
	.byte	0,124,102,124,102,124,0,0
	.byte	0,126,96,96,96,126,0,0
	.byte	0,124,102,102,102,124,0,0
	.byte	0,126,96,120,96,126,0,0
	.byte	0,126,96,120,96,96,0,0
	.byte	0,126,96,110,102,126,0,0
	.byte	0,102,102,126,102,102,0,0
	.byte	0,24,0,24,24,24,0,0
	.byte	0,12,12,12,108,56,0,0
	.byte	0,102,108,120,108,102,0,0
	.byte	0,96,96,96,96,126,0,0
	.byte	0,119,107,107,99,99,0,0
	.byte	0,102,118,110,102,102,0,0
	.byte	0,126,102,102,102,126,0,0
	.byte	0,126,102,126,96,96,0,0
	.byte	0,126,102,102,108,122,0,0
	.byte	0,124,102,124,102,102,0,0
	.byte	0,62,96,60,6,124,0,0
	.byte	0,126,24,24,24,24,0,0
	.byte	0,102,102,102,102,60,0,0
	.byte	0,102,102,102,60,24,0,0
	.byte	0,99,99,107,107,119,0,0
	.byte	0,102,60,24,60,102,0,0
	.byte	0,102,102,60,24,24,0,0
	.byte	0,126,12,24,48,126,0,0
	.byte	0,102,24,102,126,102,0,0
	.byte	254,254,254,0,239,239,239,0
	.byte	255,171,213,161,193,161,193,255
	.byte	0,255,85,170,0,255,255,0
	.byte	86,102,86,102,86,102,86,102
	.byte	0,0,0,0,0,0,0,0
	.byte	84,170,84,0,69,170,69,0
	.byte	255,255,255,255,255,255,255,255
	.byte	0,0,0,0,0,0,0,0
	.byte	24,62,96,60,6,124,24,0
	.byte	98,102,12,24,48,102,70,0
	.byte	60,102,60,56,103,102,63,0
	.byte	6,12,24,0,0,0,0,0
	.byte	12,24,48,48,48,24,12,0
	.byte	48,24,12,12,12,24,48,0
	.byte	0,102,60,255,60,102,0,0
	.byte	0,24,24,126,24,24,0,0
	.byte	0,0,0,0,0,24,24,48
	.byte	0,0,0,126,0,0,0,0
	.byte	0,0,0,0,0,24,24,0
	.byte	0,3,6,12,24,48,96,0
	.byte	0,60,110,118,102,60,0,0
	.byte	0,24,56,24,24,24,0,0
	.byte	0,60,70,12,48,126,0,0
	.byte	0,60,70,28,70,60,0,0
	.byte	0,22,54,102,127,6,0,0
	.byte	0,126,96,126,6,126,0,0
	.byte	0,60,96,124,102,60,0,0
	.byte	0,126,6,12,24,24,0,0
	.byte	0,60,102,60,102,60,0,0
	.byte	0,60,102,62,6,60,0,0


.segment       	"STARTUP"

; BASIC header with a SYS call

        .word   Head            ; Load address
Head:   .word   @Next
        .word   $2        ; Line number
        .byte   $9E             ; SYS token
        .byte   <(((@Start / 1000) .mod 10) + $30)
        .byte   <(((@Start /  100) .mod 10) + $30)
        .byte   <(((@Start /   10) .mod 10) + $30)
        .byte   <(((@Start /    1) .mod 10) + $30)
        .byte   ':'             ; End of BASIC line
		;.word	$3
        .byte   $93             ; LOAD token
		.byte   $22,'D','A','T','A',$22,',','8'
        .byte   $00             ; End of BASIC line
@Next:  .word   0               ; BASIC end marker
@Start:

; ------------------------------------------------------------------------
; Actual code

	ldx    	#zpspace-1
L1:	lda	sp,x
   	sta	zpsave,x	; Save the zero page locations we need
	dex
       	bpl	L1

; Close open files

	jsr	CLRCH

; Clear the BSS data

	jsr	zerobss

; Save system stuff and setup the stack

       	tsx
       	stx    	spsave 		; Save the system stack ptr

	lda    	#<(__RAM_START__ + __RAM_SIZE__)
	sta	sp
	lda	#>(__RAM_START__ + __RAM_SIZE__)
    sta	sp+1   		; Set argument stack ptr

; Call module constructors

	jsr	initlib

; If we have IRQ functions, chain our stub into the IRQ vector

        lda     #<__INTERRUPTOR_COUNT__
      	beq	NoIRQ1
      	lda	IRQVec
       	ldx	IRQVec+1
      	sta	IRQInd+1
      	stx	IRQInd+2
      	lda	#<IRQStub
      	ldx	#>IRQStub
      	sei
      	sta	IRQVec
      	stx	IRQVec+1
      	cli

; Push arguments and call main()

NoIRQ1: jsr     callmain

; Back from main (This is also the _exit entry). Reset the IRQ vector if we
; chained it.

_exit: 	pha  			; Save the return code on stack
	lda     #<__INTERRUPTOR_COUNT__
	beq	NoIRQ2
	lda	IRQInd+1
	ldx	IRQInd+2
	sei
	sta	IRQVec
	stx	IRQVec+1
	cli

; Run module destructors

NoIRQ2: jsr	donelib

; Copy back the zero page stuff

       	ldx	#zpspace-1
L2:	lda	zpsave,x
	sta	sp,x
	dex
       	bpl	L2

; Place the program return code into ST

	pla
	sta	ST

; Restore the stack pointer

  	ldx	spsave
	txs

; Reset changed vectors, back to basic

	jmp	RESTOR


; ------------------------------------------------------------------------
; The IRQ vector jumps here, if condes routines are defined with type 2.

IRQStub:
	cld    	       		   	; Just to be sure
       	jsr    	callirq                 ; Call the functions
       	jmp    	IRQInd			; Jump to the saved IRQ vector

; ------------------------------------------------------------------------
; Data

.data

zpsave:	.res	zpspace
IRQInd: jmp     $0000

.bss

spsave:	.res	1

