#include "audio.h"

typedef unsigned char	byte;
typedef unsigned short	word;

#define SCREEN_ADDR		0x1E00
#define COL_ADDR		0x9600
#define SCREEN_TO_COL	(COL_ADDR-SCREEN_ADDR)
#define SCREEN_W		22
#define SCREEN_H		23
#define POKE(_x,_y) *(byte*)(_x)=_y
#define PEEK(_x) *(byte*)(_x)
#define set_screen(_d, _c, _x, _y)	*(byte*)(SCREEN_ADDR+(_x)+(_y)*SCREEN_W) = _d; set_screen_col(_c,_x,_y)
#define set_screen_col(_c,_x,_y) *(byte*)(COL_ADDR+(_x)+(_y)*SCREEN_W) = _c
#define get_screen(_x,_y) *(byte*)(SCREEN_ADDR+(_x)+(_y)*SCREEN_W)
#define get_screen_col(_x,_y) *(byte*)(COL_ADDR+(_x)+(_y)*SCREEN_W)

byte* ptr1;

static byte* mem_x;
static byte* mem_y;
static byte mem_d;
static byte mem_l;

#define memset(_x,_d,_l) mem_x = (_x); mem_d = (_d); mem_l = (_l); _memset()
#define memcpy(_x,_y,_l) mem_x = (_x); mem_y = (byte*)(_y); mem_l = (_l); _memcpy()
void _memset() {label1: --mem_l;mem_x[mem_l] = mem_d; if (mem_l) goto label1;}
void _memcpy() {label1: --mem_l;mem_x[mem_l] = mem_y[mem_l]; if (mem_l) goto label1;}

#define A(_x) (_x-0x40),
#define N(_x) (_x-'0'+48),

#define TEXT(_y,_t,_c) memcpy((byte*)(SCREEN_ADDR+(_y)*SCREEN_W+((SCREEN_W-sizeof(_t))>>1)),_t,sizeof(_t));memset((byte*)(COL_ADDR+(_y)*SCREEN_W+((SCREEN_W-sizeof(_t))>>1)),_c,sizeof(_t));\
	memset((byte*)(SCREEN_ADDR+(_y+1)*SCREEN_W+((SCREEN_W-sizeof(_t))>>1)),33,sizeof(_t));

#define TEXT2(_y,_t,_c) memcpy((byte*)(SCREEN_ADDR+(_y)*SCREEN_W+((SCREEN_W-sizeof(_t))>>1)),_t,sizeof(_t));memset((byte*)(COL_ADDR+(_y)*SCREEN_W+((SCREEN_W-sizeof(_t))>>1)),_c,sizeof(_t))

const byte tx1[] = {A('M')A('I')A('S')A('F')A('I')A('T')28,A('P')A('R')A('E')A('S')A('E')A('N')A('T')A('S')};
const byte tx2[] = {A('L')A('U')A('D')A('U')A('M')28,A('D')A('A')A('R')A('E')28,N('2')N('7')28,A('G')A('A')A('M')A('E')};
const byte tx3[] = {A('F')A('A')A('S')A('T')A('B')A('O')A('Y')};
const byte tx3_2[] = {A('C')A('O')A('L')A('L')A('E')A('C')A('T')28,A('A')A('L')A('L')28,A('D')A('I')A('A')A('M')A('O')A('N')A('D')A('S')};
const byte tx4[] = {A('P')A('R')A('E')A('S')A('S')28,A('F')A('I')A('R')A('E')};
const byte tx5_1[] = {A('P')A('A')A('L')28,A('M')A('O')A('D')A('E')};
const byte tx5_2[] = {A('N')A('T')A('S')A('C')28,28,A('M')A('O')A('D')A('E')};
const byte tx6[] = {A('L')A('O')A('A')A('D')A('I')A('N')A('G')};

#define BYTE ,
const byte gfx[]=
{
		255,213,169,193,161,193,129,255
	BYTE	240,240,240,240,15,15,15,15
	BYTE	250,245,250,245,175,95,175,95
	BYTE	98,82,98,82,98,82,98,82
	BYTE	0,255,170,85,0,0,255,0
	BYTE	60,94,191,255,255,255,126,60
	BYTE	0,60,94,126,126,126,60,0
	BYTE	0,0,24,44,60,24,0,0
	BYTE	0,60,66,90,90,66,60,0
	BYTE	126,129,189,165,165,189,129,126
	BYTE	24,44,94,175,255,126,60,24
	BYTE	24,60,126,255,245,122,52,24
	BYTE	0,0,211,146,146,219,0,0
	BYTE	0,0,181,166,166,181,0,0
	BYTE	0,0,0,0,0,0,0,0
};

const byte song[] = 
	{0x03,F3,F1,0x01,A3,0x01,C4,
	 0x01,F3,0x01,A3,0x01,C4,
	 0x01,F3,0x01,A3,0x01,C4,
	 0x01,F3,0x01,B3,0x01,D3, 
	 0x03,E3,E1,0x01,A3,0x01,C4,
	 0x01,E3,0x01,A3,0x01,C4,
	 0x01,E3,0x01,A3,0x01,C4,
	 0x01,E3,0x01,B3,0x01,D3,
	 0x80};

word tone_update;
byte vol_update;
byte a_i;
byte a_k;
byte a_j;
byte a_cursor;
byte a_vol;
void sound_update()
{
	++tone_update;
	++vol_update;
	while (PEEK(0x9004) <= 110);
	if (tone_update > 10)
	{
		tone_update = 0;
		a_i=0;
		a_k=1;
		start:
			a_j = (*(song+a_cursor)>>a_i)&0x01;
			if (a_j) POKE(0x900A+a_i,*(song+a_cursor+a_k)*a_j);
			a_k = a_k + a_j;
			++a_i;
			if (a_i < 3) goto start;
		a_cursor +=a_k;
		if (*(song+a_cursor)&0x80) a_cursor=0;
		a_vol=0x0D;
	}
	if (vol_update > 0) 
	{
		vol_update=0;
		POKE(0x900E,a_vol);
		if (a_vol) --a_vol;
	}
	while (PEEK(0x9004) >= 40);
}

void fill_screen(byte d, byte c, byte x, byte y, byte w, byte h)
{
	ptr1 = (byte*)(SCREEN_ADDR+x+y*SCREEN_W);
next_line:
	--h;
	memset(ptr1,d,w);
	memset(ptr1+SCREEN_TO_COL,c,w);
	ptr1+= SCREEN_W;
	if (h) goto next_line;
}

byte raster;
byte pal;
byte res;
byte i,j,k;
void main(void) 
{
	raster = 0;
	pal = 0;
	while (PEEK(0x9004) <= 100);
	i=0;
	while (i < 0xff )
	{
		++i;
		res = PEEK(0x9004);
		if (raster < res)
		{
			raster = res;
		}
	}
	if (raster > 140)
	{
		pal = 1;
	}
	POKE(0x900F,0x00|0x00|0x08);
	POKE(0x9122,0x7F);
	POKE(0x9005,0xFF);
	fill_screen(33,2, 0,0,SCREEN_W,1);
	fill_screen(28,2, 0,1,SCREEN_W,SCREEN_H-2);
	fill_screen(33,2, 0,SCREEN_H-1,SCREEN_W,1);
	TEXT(2,tx1,2);
	TEXT(4,tx2,2);
	TEXT(7,tx3,7);
	TEXT(12,tx3_2,2);
	TEXT(SCREEN_H-3,tx4,3);
	if (pal) 
	{
		TEXT(SCREEN_H-5,tx5_1,2);
	}
	else 
	{
		TEXT(SCREEN_H-5,tx5_2,2);
	}
	j=2;
next_line:
	k=0;
next_byte:
	i = get_screen(k,j);
	if (i == 28)
	{
		if (get_screen_col(k,j) != 2)
		{
			set_screen(28,2,k,j);
		}
	}
	else if (i == 33)
	{
		if (get_screen(k,j-1) == 28)
		{
			set_screen(28,2,k,j);
		}
	}
	++k;
	if (k < SCREEN_W) goto next_byte;
	++j;
	if (j<SCREEN_H-1) goto next_line;

	POKE(0x900E,0x0D);
	j=0;
	while ( (PEEK(0x9111)&0x20)!=0 && PEEK(0xC5)!=0x20)
	{
		sound_update();
		j ^=0x01;
		if (j)
		{
			i = *(byte*)(0x1c00+33*8+7);
			memcpy((byte*)(0x1c00+33*8+1),(byte*)(0x1c00+33*8),7);
			*(byte*)(0x1c00+33*8)=i;
			i = *(byte*)(0x1c00+28*8+7);
			memcpy((byte*)(0x1c00+28*8+1),(byte*)(0x1c00+28*8),7);
			*(byte*)(0x1c00+28*8)=i;
		}
	}

	POKE(0x900E,0);
	fill_screen(0,0,0,0,SCREEN_W,SCREEN_H);
	memcpy((byte*)0x298,&gfx[0],12*8);
	memcpy((byte*)0x340,&gfx[12*8],sizeof(gfx)-12*8);
	memset((byte*)0x180,0,0x61);
	fill_screen(32,0,0,0,SCREEN_W,SCREEN_H);
	POKE(0x900A,0x00);
	POKE(0x900B,0x00);
	POKE(0x900C,0x00);
	POKE(0x9005,0xF0);
	TEXT2(SCREEN_H>>1,tx6,7);
	POKE(0x900F,0x02|0x20|0x08);
}
