#include "audio.h"

typedef unsigned char	byte;
typedef unsigned short	word;

#define SCREEN_ADDR		0x1E00
#define COL_ADDR		0x9600
#define SCREEN_TO_COL	(COL_ADDR-SCREEN_ADDR)
#define SCREEN_W		22
#define SCREEN_H		23
#define POKE(_x,_y) *(byte*)(_x)=_y
#define PEEK(_x) *(byte*)(_x)

unsigned char YY;	
#define kcall(name, a, x, y)		 	   			\
    YY = y;				 	   			\
    __AX__ = ((unsigned)(x) << 8) + (a); 	   			\
    asm("\tldy\t_YY");				   			\
    asm("\tjsr\t" #name);

byte* ptr1;
byte i,j,k,l;
byte x,y;
byte player_anim;

static byte* mem_x;
static byte* mem_y;
static byte mem_d;
static byte mem_l;

#define memset(_x,_d,_l) mem_x = (_x); mem_d = (_d); mem_l = (_l); _memset()
#define memcpy(_x,_y,_l) mem_x = (_x); mem_y = (byte*)(_y); mem_l = (_l); _memcpy()
void _memset() {label1: --mem_l;mem_x[mem_l] = mem_d; if (mem_l) goto label1;}
void _memcpy() {label1: --mem_l;mem_x[mem_l] = mem_y[mem_l]; if (mem_l) goto label1;}

#define A(_x) ((_x)-0x40),
#define N(_x) ((_x)+'0')

#define TEXT(_y,_t,_c,_l) memcpy((byte*)(SCREEN_ADDR+(_y)*SCREEN_W+((SCREEN_W-_l)>>1)),_t,_l);memset((byte*)(COL_ADDR+(_y)*SCREEN_W+((SCREEN_W-_l)>>1)),_c,_l)
#define TXT(_t) _t ,sizeof(_t)

const byte tx1[]={A('G')A('E')A('T')32,A('R')A('E')A('A')A('D')A('Y')};
const byte tx2[]={A('G')A('A')A('M')A('E')32,A('O')A('V')A('E')A('R')};
const byte tx3[]={A('P')A('R')A('E')A('S')A('S')32,32,A('F')A('I')A('R')A('E')};
const byte tx4[]={A('S')A('C')A('O')A('R')A('E')32,32,32,32,32,32};

#define draw_screen(_d, _x, _y, _w, _h) _fill_screen((byte*)SCREEN_ADDR,_d,_x,_y,_w,_h)
#define draw_screen_line(_d, _x, _y, _l) memset((byte*)(SCREEN_ADDR+(_x)+(_y)*SCREEN_W),_d,_l)
#define color_screen(_c,_x,_y,_w,_h) _fill_screen((byte*)COL_ADDR,_c,_x,_y,_w,_h)
#define color_screen_line(_c,_x,_y,_l) memset((byte*)(COL_ADDR+(_x)+(_y)*SCREEN_W),_c,_l)
#define set_screen(_d, _c, _x, _y)	*(byte*)(SCREEN_ADDR+(_x)+(_y)*SCREEN_W) = _d; set_screen_col(_c,_x,_y)
#define set_screen_col(_c,_x,_y) *(byte*)(COL_ADDR+(_x)+(_y)*SCREEN_W) = _c
#define get_screen(_x,_y) *(byte*)(SCREEN_ADDR+(_x)+(_y)*SCREEN_W)
#define get_screen_col(_x,_y) *(byte*)(COL_ADDR+(_x)+(_y)*SCREEN_W)

void _fill_screen(byte* ptr, byte d, byte x, byte y, byte w, byte h)
{
	ptr += (x+y*SCREEN_W);
next_line:
	--h;
	memset(ptr,d,w);
	ptr+= SCREEN_W;
	if (h) goto next_line;
}

#define WALL		(83+0)
#define EMPTY		(83+1)
#define EMPTY_DARK	(83+2)
#define WALL_UP		(83+3)
#define WALL_LEFT	(83+4)
#define PLAYER		(83+5)
#define ENEMY_A		(83+8)
#define DIAMOND_A	(83+10)
#define CLOCK_1		(83+21)
#define CLOCK_2		(83+22)
#define ENEMY		(83+23)
#define DIAMOND		(83+24)

#define PLAYER_COL	1
#define EMPTY_COL	0
#define CLOCK_COL	1
#define ENEMY_COL	3
#define DIAMOND_COL	7
#define CLOCK_OFFSET	3
#define MAX_ENEMIES	19

byte joy,tmp;
byte x_dest;
byte y_dest;
byte player_id;
byte old_x;
byte old_y;
byte clock;
byte second;
byte one_second;
byte score;
byte diamonds;
byte level;
byte enemy_x[MAX_ENEMIES];
byte enemy_y[MAX_ENEMIES];
byte enemy_d[MAX_ENEMIES];

void wait(byte time)
{
	next:
	while (PEEK(0x9004) > 0);
	while (PEEK(0x9004) < 10);
	--time;
	if (time) goto next;
}

void show_text(const byte* t, byte l,byte w)
{
	POKE(0x900E,0);
	color_screen(2,0,0,SCREEN_W,SCREEN_H);
	POKE(0x9005,0xF0);
	TEXT(SCREEN_H>>1,t,7,l);
	if (t == tx2)
	{
		TEXT((SCREEN_H>>1)+2,tx4,1,sizeof(tx4));
		set_screen(N(score/100),1,13,(SCREEN_H>>1)+2);
		set_screen(N((score%100)/10),1,14,(SCREEN_H>>1)+2);
		set_screen(N(score%10),1,15,(SCREEN_H>>1)+2);
		w = 0;
		level = 1;
		TEXT((SCREEN_H>>1)+4,tx3,7,sizeof(tx3));
	}
	if (w) 
	{
		wait(200);
	}
	else
	{
		while ( (PEEK(0x9111)&0x20)!=0);
	}
	color_screen(2,0,0,SCREEN_W,SCREEN_H);
	POKE(0x9005,0xF8);
}

byte lx;
byte ly;
byte anim;
byte enemy_check;
byte vol;
byte jj,kk;
byte old_x_dest;
byte old_y_dest;
byte move_c;

void create_level(byte ii)
{
	color_screen(2,0,0,SCREEN_W,SCREEN_H);
	draw_screen(WALL,		0,0,SCREEN_W,SCREEN_H-1);
	draw_screen(WALL_UP,	0,1,SCREEN_W,SCREEN_H-3);
	draw_screen(WALL_LEFT,	1,0,SCREEN_W-2,SCREEN_H-1);
	draw_screen(EMPTY,		1,1,SCREEN_W-2,SCREEN_H-3);
	draw_screen(EMPTY_DARK,	1,1,SCREEN_W-2,1);
	color_screen(EMPTY_COL,0,0,SCREEN_W,SCREEN_H);
	draw_screen_line(PLAYER+2, 0,SCREEN_H-1,SCREEN_W);
	set_screen(CLOCK_1,CLOCK_COL,0,SCREEN_H-1);
	set_screen(CLOCK_2,CLOCK_COL,1,SCREEN_H-1);

	j=MAX_ENEMIES-1;
next_enemy:
	enemy_d[j] = 0xff;
	--j;
	if (j) goto next_enemy;

	j=ii;
	POKE(0x8C,ii);

	next:
	kcall($e094,1,0,0);
	lx = PEEK(0x8C)&(0x0F);
	kcall($e094,1,0,0);
	ly = PEEK(0x8C)&(0x0F);
	if (j < MAX_ENEMIES) 
	{
		enemy_x[j] = 1+lx;
		enemy_y[j] = 2+ly;
		enemy_d[j] = lx&0x03;
	}
	--j;
	if (j) goto next;

	j=20-ii;
	next2:
	kcall($e094,1,0,0);
	lx = PEEK(0x8C)&(0x0F);
	kcall($e094,1,0,0);
	ly = PEEK(0x8C)&(0x0F);
	set_screen(DIAMOND,DIAMOND_COL,1+lx,2+ly);
	--j;
	if (j) goto next2;

	set_screen(PLAYER,PLAYER_COL,x,y);
}

void main(void) 
{
	show_text(TXT(tx3),0);
	//score = 0;
	level = 1;
	old_x_dest = 1;
	old_y_dest = 1;
again:
	x = SCREEN_W-2;
	y = SCREEN_H-3;
	old_x = x;
	old_y = y;
	show_text(TXT(tx1),1);
	create_level(level);
	
	clock = 10;
	draw_screen_line(PLAYER, CLOCK_OFFSET,SCREEN_H-1,clock);
	color_screen_line(PLAYER_COL,CLOCK_OFFSET,SCREEN_H-1,clock);

	one_second = 50;
	second = one_second;
	diamonds = 0;
	player_id = PLAYER;
	anim = 0;
	while(1)
	{
		--second;
		if (!second)
		{
			if (!clock)
			{
				if (diamonds == 0)
				{
					show_text(TXT(tx2),1);
					score = 0;
				}
				else
				{
					++level;
					//POKE(0x900A,D3);POKE(0x900E,0xF);
					//wait(20);
				}
				goto again;
			}
			set_screen(PLAYER+2,0,CLOCK_OFFSET+clock,SCREEN_H-1);
			second = one_second;
			--clock;
		}
		++jj;
		if (!(jj&0x3))
		{
			jj=0;
			i = *(byte*)(EMPTY*8+7);
			memcpy((byte*)(EMPTY*8+1),(byte*)(EMPTY*8),7);
			*(byte*)(EMPTY*8)=i;
			i = *(byte*)(EMPTY_DARK*8+7);
			memcpy((byte*)(EMPTY_DARK*8+1),(byte*)(EMPTY_DARK*8),7);
			*(byte*)(EMPTY_DARK*8)=i;
		}
		joy = PEEK(0x9111);

		x_dest = x;
		y_dest = y;
		if (!(joy&0x04))  
		{
			--y_dest; 
			old_x_dest = 1;
			old_y_dest = 0;
		} 
		else 
		{
			if (!(joy&0x08)) 
			{
				++y_dest;
				old_y_dest = 2;
				old_x_dest = 1;
			} 
			else
			{
				if (!(joy&0x10)) 
				{
					--x_dest;
					old_x_dest = 0;
					old_y_dest = 1;
				}
				else
				{
					joy = PEEK(0x9120);
					if (!(joy&0x80)) 
					{
						++x_dest;
						old_x_dest = 2;
						old_y_dest = 1;
					}
					else
					{
						++move_c;
						if (move_c == 5)
						{
							x_dest += -1+old_x_dest;
							y_dest += -1+old_y_dest;
							move_c=0;
						}
					}
				}
			}
		}
		tmp = get_screen(x_dest,y_dest);
		if (tmp == EMPTY || tmp == PLAYER+2)
		{
			set_screen(PLAYER+2,PLAYER_COL,x,y);
			set_screen(EMPTY,EMPTY_COL,old_x,old_y);
			old_x = x;
			old_y = y;
			x = x_dest;
			y = y_dest;
			set_screen(player_id,PLAYER_COL,x,y);
		}
		if (tmp == WALL_UP || tmp == WALL_LEFT || tmp == EMPTY_DARK)
		{
			old_x_dest = 2-old_x_dest;
			old_y_dest = 2-old_y_dest;
		}
		if (tmp == player_id)
		{
			set_screen(EMPTY,EMPTY_COL,old_x,old_y);
		}
		set_screen(player_id,PLAYER_COL,x,y);
		if (tmp == ENEMY)
		{
			POKE(0x900A,C1);POKE(0x900E,0xF);
			POKE(0x900F,0x01|0x10|0x08);
			wait(10);
			POKE(0x900F,0x02|0x20|0x08);
			wait(50);
			show_text(TXT(tx2),1);
			score=0;
			goto again;
		}
		if (tmp == DIAMOND)
		{
			POKE(0x900A,C3);vol=0x0F;
			set_screen(EMPTY,EMPTY_COL,x_dest,y_dest);
			if (score<0xFF) ++score;
			++diamonds;
			POKE(0x900F,0x77|0x08);
			wait(2);
			POKE(0x900F,0x22|0x08);
			wait(2);
		}

		++kk;
		if (!(kk&0x7))
		{
			++player_anim;
			if (player_anim >= 2) player_anim = 0;
			player_id = PLAYER+player_anim;
			anim^=0x01;
			memcpy((byte*)(ENEMY*8),(byte*)((ENEMY_A+anim)*8),8);
			memcpy((byte*)(DIAMOND*8),(byte*)((DIAMOND_A+anim)*8),8);
		}

		enemy_check^=0x01;
		if (enemy_check)
		{
			if (vol) 
			{
				--vol;
			}
			else
			{
				POKE(0x900A,0);
			}
			POKE(0x900E,vol);
			i = MAX_ENEMIES-1;
next_enemy:
			j = enemy_d[i];
			if ( j != 0xff )
			{
				k = enemy_x[i];
				l = enemy_y[i];
				set_screen(EMPTY,EMPTY_COL,k,l);
				if (k <= 1)
				{
					j = 2;
				}
				else if (k >= SCREEN_W-2)
				{
					j = 0;
				}
				if (l <= 2)
				{
					j = 3;
				}
				else if (l >= SCREEN_H-3)
				{
					j = 1;
				}
				enemy_d[i] = j;
				if (j == 0)
				{
					--enemy_x[i];
				}
				else if (j == 1)
				{
					--enemy_y[i];
				}
				else if (j == 2)
				{
					++enemy_x[i];
				}
				else 
				{
					++enemy_y[i];
				}
				set_screen(ENEMY,ENEMY_COL,enemy_x[i],enemy_y[i]);
			}
			--i;
			if (i) goto next_enemy;
		}
		wait(1);
	}
}
